# Vanilla Void
Have you ever died with Pluripotent Larva and thought, "wow, that didn't corrupt literally all of my items. this game sucks!" I uh, me neither, but..anyway...

This mod adds 9 void items: 5 common/tier-1, 3 uncommon/tier-2, and 1 legendary/tier-3. 
<p>Additionally, the mod offers some tweaks to Void Locus, those being an exit portal and the option to give the stage director more credits, a new interactable, allowing you to revisit the void fields at the cost of a void item, and improved pickup highlights for void items.
<p><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/Readme%20Images/readmeImage1.png?raw=true" width=1445>

<p>This mod (clearly) requires Survivors of the Void.

# New Void Items
Both the base and stacking effects of these items are customizable. You can also turn any or all of the items off, if you're in to that sort of thing.
<table>
	<thead>
		<tr>
			<th>Icon</th>
			<th>Name/Effect</th>
                        <th>Non-Void Pair</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td colspan="3" align="center"><h3>Common / Tier 1 Items</h3></td>
		</tr>
		<tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/adzeIcon512.png?raw=true" width=128></td>
			<td>
				<b>Abyss-Touched Adze</b><br>
				Deal more damage to enemies with lower health. Scales linearly the less health a given enemy has.
			</td>
                        <td> 
				Corrupts all <b>Crowbars</b>.
			</td>
		</tr>
		<tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/watchIcon512.png?raw=true" width=128></td>
			<td>
				<b>Clockwork Mechanism</b><br>
			        Gain items at the start of the next stage. Breaks a random item at low health.<p><b>---</b><p> This item has multiple variants, with a lot of customization. You can select which you'd prefer to use in the config.
			</td>
                        <td> 
				Corrupts all <b>Delicate Watches</b>.
			</td>
		</tr>
                <tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/vialsIcon512.png?raw=true" width=128></td>
			<td>
				<b>Enhancement Vials</b><br>
				Upgrade an item at low health. Consumed on use. At the start of each stage, a stack regenerates.
			</td>
                        <td> 
				Corrupts all <b>Power Elixirs</b>.
			</td>
		</tr>
                 <tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/ventIcon512.png?raw=true" width=128></td>
			<td>
				<b>Extraterrestrial Exhaust</b><br>
				Upon activating a skill, fire a number of rockets depending on the skill's cooldown.
			</td>
                        <td> 
				Corrupts all <b>Bundles of Fireworks</b>.
			</td>
		</tr>
                <tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/cryoIcon512.png?raw=true" width=128></td>
			<td>
				<b>Supercritical Coolant</b><br>
				Killing an enemy slows and eventually freezes other nearby enemies.
			</td>
                        <td> 
				Corrupts all <b>Gasolines</b>.
			</td>
		</tr>
			<td colspan="3" align="center"><h3>Uncommon / Tier 2 Items</h3></td>
		</tr>
		<tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/lotusIcon512.png?raw=true" width=128></td>
			<td>
				<b>Crystalline Lotus</b><br>
				Periodically release a slowing pulse during the Teleporter event and 'Holdout Zones' such as the Void Fields.<p><b>---</b><p> This item has another variant. You can select which you'd prefer to use in the config.
			</td>
                        <td> 
				Corrupts all <b>Lepton Daisies</b>.
			</td>
		</tr>
		<tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/bladeIcon512.png?raw=true" width=128></td>
			<td>
				<b>Executioner's Burden</b><br>
				Your 'On-Kill' effects occur an additional time upon killing an elite. Additionally causes a damaging AOE upon elite kill.
			</td>
                        <td> 
				Corrupts all <b>Old Guillotines</b>.
			</td>
		</tr>
<tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/quillIcon512.png?raw=true" width=128></td>
			<td>
				<b>Quasitemporal Quill</b><br>
				Gain an airdash.
			</td>
                        <td> 
				Corrupts all <b>Hopoo Feathers</b>.
			</td>
		</tr>
                        <td colspan="3" align="center"><h3>Legendary / Tier 3 Items</h3></td>
		</tr>
                <tr>
			<td><img src="https://github.com/Zenithrium/vanillaVoid/blob/master/vanillaVoid/Icons/orreryIcon512.png?raw=true" width=128></td>
			<td>
				<b>Lens-Maker's Orrery</b><br>
				Non-critical hits grant a stacking damage bonus that is lost upon critting.<p><b>---</b><p> This item has another variant. You can select which you'd prefer to use in the config.
              		</td>
                        <td> 
				Corrupts all <b>Laser Scopes</b>.
			</td>
		</tr>
	</tbody>
</table>

# Special Thanks

- Thank you to...
  - KomradeSpectre, for the item boilerplate and tutorial
  - RumblingJOSEPH, both for VoidAPI but also for helping me figure everything out time and time again
  - Corn-Lord for the concept, name, and general lore, and Voidsenight for the design inspiration of Lens-Maker's Orrery, from their RoR2 Ideas document, found here: https://docs.google.com/document/d/1mRj_wADu0cru9Kmp0sPquV-leUX_CwVtbXGYLxXFDK0/edit?usp=sharing
  - Slipskip, for the effect and visual inspiration for Quill
  - Caliph Index, for Shattered Monolith's effect
  - Heyimnoop, for making the original Adze icon, helping with the current Lotus and Orrery icons, and for putting up with me being hilariously stupid, and Groove_Salad for help with the Coolant icon
  - PIEisFANTASTIC and thejanjan for one of the Orrery variants
  - Conq, for the idea for a variant of Clockwork
  - Harb, for helping with me with IL hooks
  - RandomlyAwesome, for helping me hook into the right part of the stage manager for Clockwork and for spending like half an hour with me trying to fix something that was completely my fault
  - iDeathHD and Bubbet for helping with spawning Executioner's Burden properly, and iDeathHD again for helping with prefabs with Exhaust
  - ThinkInvis and TinkersSatchel for inspiration (read: being stolen from) on how the thunderstore page looks now
  - SomeoneElse and Noop for help with the slow VFX for Lotus 
  - The rest of the Starstorm 2 team for putting up with me being continuously inept :)
  - The RoR2 Modding and Starstorm 2 servers for helping refine ideas/designs and generally being kind 

# Misc
You can contact me on Discord in the RoR2 Modding server or simply message me, @Zenithrium#7082. I'd love to hear about more item ideas or if you think any item could use a buff, nerf, or even a rework. You can also check out the Github and leave a pull request or issue.

# Changelog
* v1.4.1 Tier Visual Upgrade and Quill Fix
  * Void item tiers now have their own tier border (the thing showing you where the item appears on your player), being the original tier's borders in the void color.
  * Quill's airdash now uses FixedUpdate instead of Update. Hopefully this should fix it not working for some people (Thank you RandomlyAwesome)
  * Orrery's damage bonus is no longer calculated via a damage multiplier (as it was far more volatile than other ways of increasing damage)
  * Orrery now actually takes into account the damage mult in the config.
  * Made the non-void item content of the mod have a bit more of a presence on the mod page.

* v1.4.0 An Interactible
  * Thank you for 100k downloads!!! 
  * <details><summary>Adds a new interactable, the Shattered Monolith - thank you to Caliph Index#8141 on the modding discord for the idea!</summary>Allows you to visit the void fields at the cost of a void item. Spawns somewhat often in void seeds and rarely otherwise. This should work with Fogbound Lagoon and Forgotten Relics.</details>
  * <details><summary>Updated how the mod switches from stubbed to real Hopoo shaders.</summary>I think the mod up until this point just..didn't use hopoo shaders because I forgot to set it up. Oops</details>
  * <details><summary>Increased the slow duration of Coolant back from 3 (+1) to 4 (+2)</summary>I think the item got hit hard enough by increasing the required freeze stacks from 2 to 3 so I'm reverting this change.</details>
  * <details><summary>Reduced Azde's damage from 40% (+40%) to 40% (+30%)</summary>I think the item has been slightly overpreforming, so I'm slightly lowering the stacking damage.</details>
  * Fixed the Void Locus portal's platform not appearing.
  * Fixed Clockwork only being able to give white items. 
  * Fixed Quill completely immobilizing you if you attempt to dash while nullified.
  * Fixed Orrery not stacking properly again.
  * Removed Networking API dependency as it is no longer needed.
  * Adjusted how items are internally named slightly in hopes to set up lang files eventually

* v1.3.2 Rebalance Update, Lotus Rework, and Void Locus Tweaks
  * Adds a portal to Void Locus, allowing you to return to normal stages if desired (can be disabled).
  * Adds a setting which increases the amount of credits the director gets in Void Locus, allowing for the stage to have slightly more of a reward if desired (0 additional credits by default).
  * <details><summary>Reworked Lotus - instead of barrier, slows enemies and projectiles for a duration. Old variant is still in config.</summary>This should make the item actually different from daisy, in a non-superficial way. Additionally has a slightly adjusted texture. Feedback on it would be especially welcome!</details>
  * <details><summary>Reduced the damage of Coolant from 25% (+25%) to 15% (+15%)</summary>This damage is very much intended to be a sort of tap that kills frozen enemies, it doesn't need to be very high. Removing it means the item has very little to scale from stacking, so I wanted to keep it.</details>
  * <details><summary>Reduced debuff duration of Coolant from 4s (+2s) to 3s (+1s)</summary>Helps reign in the freeze to be harder to activate consistently.</details>
  * <details><summary>Increased debuffs required for freezing from 2 -> 3</summary>Slightly increasing the amount of stacks required to freeze better fits it into its intended niche. Additionally, it no longer can stun-freeze bosses, but still allows the execute.</details>
  * <details><summary>Reduced Orrey max damage bonus from 150% to 50%</summary>It was still too strong. Hopefully this makes taking it more of a question of "would I get more out of crits?" rather than "oh hell yea 2.5x damage multipler"</details>
  * <details><summary>Reduced the damage of Exhaust from 25% (+25%) to 20% (+20%)</summary>Slightly reducing the damage in hopes to make it less of a direct upgrade compared to fireworks.</details>
  * <details><summary>Slightly increased the shothop velocity of Quill from .25 -> .5</summary>This is done to make it so you should generally be at the same height before and after dashing.</details>
  * Adjusted Orrery's buff color to a nicer purple. 
  * Fixes a bug where Lotus didn't activate during the Void Fields and Void Locus.
  * Fixed some potential NREs related to Lotus. 
  * Updates the mod to use the atomized R2API modules as dependencies. Additionally updates Bepinex to the current version rather than genuinely the one from when I started working on this mod.

* v1.3.1 Quill Fixes
  * Fixed an issue with how Quill tracked how many times the jump button had been pressed resulting in it overriding bonus jumps (ex. mercenary).
  * Fixed a bug where removing Quill didn't actually prevent you from airdashing. This doesn't really matter in contexts other than with cheats that I know if, but it's a good thing to fix.
  * Cleaned up the code a bit.

* v1.3.0 """Gearbox""" Update
  * Added Quasitemporal Quill, void Hopoo Feather. Effect and design inspiration by Slipskip#0372 from the SS2 discord. Thank you for the idea!
  * Slightly adjusted the visuals for Lotus

<details><summary>Old Changelogs</summary>
* v1.2.2 Config Changes
  * Broken items no longer have their own enable/disable options. They're always enabled, which doesn't matter because they'll never get used unless their non-broken version exists. 
  * Broken Clockwork no longer relies on Clockwork, so that nothing breaks if you disable it. 
  * Probably reset your configs. Nothing should break if you don't, but they'll be a lot cleaner if you do. 
  * Cleaned up the README a little bit. 

* v1.2.1 Some Adjustments
  * Nerfed Orrery - its numbers were majorly overtuned. 250% -> 150% damage increase. Still may be a bit strong.
  * Buffed Executioner's Burden - it now has a weak-ish aoe that activates every time it ticks. This makes the item less reliant on having other on-death items. Only downside is the logbook description is even longer now. yay.
  * Improved wording in Orrery's descriptions and fixed a typo in the config. 
  * Orrery actually stacks now. Oops.
  * Added item displays for Orrey for Starstorm 2's characters. I forgot to do it last time.
  * Clockwork's cooldown buff now stacks and shows the remaining seconds before it expires. No actual change, but it looks nicer now.
  * Fixed a bug where disabling Enhancement Vials without disabling Empty Vials would break interactable spawning. Now it just breaks if you do it the other way around. So don't do that.

* v1.2.0 Finally Something New
  * Added Supercritical Coolant, void Gasoline. 
  * Reworked Orrery to be based around not critting. As much as I do like the double, triple, etc crits of the original version, I don't think there's really a reason to not pick it up compared to laser scope. They both buff crits, one in a consistent way, and another in a weird way. This change makes picking the item up have some thought to it.
  * Maybe fixed a bug with Clockwork not applying its cooldown debuff properly for clients. 
  * Added IDRs for Starstorm 2's characters.
  * Sorry it took so long to get new stuff out - I've been working on starstorm! go play it!

* v1.1.13 Minor Fixes
  * Fixed exhaust overpreforming with Visions of Heresy - now only fires missiles for every other skill cast 
  * Clockwork no longer triggers from damage without an attacker (ex. fall damage, void fog, etc. fall damage (and most other applicable sources) don't need to be that harsh, and void fog obliterated this item)

* v1.1.12 Exhaust Fix
  * Finally fixed exhaust not working in multiplayer. It should work properly for clients.

* v1.1.11 Adze Rewrite
  * Adjusted the code for Adze so it REALLY shouldn't cause extremely large numbers.

* v1.1.10 Stupider Fix
  * Unruined the code. Oops.

* v1.1.9 Stupid Fix
  * Made the offending code just have a config option. If you're having a weird issue like health bars vanishing, just turn the option off in Orrery's config. I'd remove it or find a better way to fix this, but I can't properly replicate it and it's only an issue with another mod I can't identify.

* v1.1.8 HP Bar / IL Hook Fix
  * Improved IL hook for Orrery / Lost Seer's interaction so it shouldn't cause an NRE
  * Thank you HIFU for helping me with the IL hook 

* v1.1.7 Clockwork Rework Again & Fixes Again
  * Another Clockwork rework suggested by a friend of mine. Configs for Clockwork should be entirely reset. Old variants are still available
  * Fixed Orrery not working on Railgunner
  * Fixed Lotus-related NREs

* v1.1.6 Clockwork Rework & Fixes
  * Added Clockwork Rework / Variant, idea courtesy of Conq on the modding discord. You can still use the old variant if you'd like, but the config will by default be the new version
  * Fixed some phrasing / small issues in the logbook and config
  * Improved config for Vials
  * Fixed Blade and Lotus not properly showing up in multiplayer
  * Fixed Lotus's positioning on the Celestial Portal
  * Fixed Lotus generally behaving strangely
  * Slightly updated logo

* v1.1.5: Minor Buffs Update
  * 'Updated' the mod to newest version - I don't think anything was actually broken, but now it should be even less broken, hopefully
  * Retroactively credited PIEisFANTASTIC and thejanjan for the orrey rework idea because I forgot to (sorry!!)
  * Buffs Vials to regenerate one per stage, because getting a void item that's only purpose is to destroy itself sucks
  * Makes Exhaust actually work with ICBM
  * Fixed Vials and Clockwork not breaking from fall damage
  * Known bug - exhaust projectiles don't properly disappear as a client in multiplayer

* v1.1.4: Oops Update
  * Unbreaks critting
  * Maybe fixes orrery, it was the culprit so it might work a little differently now but it's what was intended

* v1.1.3: Logbook Updates & Fixes
  * Redid logbook displays for most of the items
  * Fixed a typo in Executioner's Burden's logbook entry 
  * Fixed coloring in Orrery's logbook entry, and reworded it to no longer mention "dipping", rather "occurances"

* v1.1.2: Modded Item Displays and Lotus
  * Added Crystalline Lotus
  * Reworked Lens-Maker's Orrery, rework idea courtesy of PIEisFANTASTIC and thejanjan on the mod's github
  * Redid icons for Clockwork and Orrery
  * Added item displays for Enforcer, Nemforcer, Dancer, and Myst
  * Also added displays for Paladin and Miner but those mods aren't fully updated yet, so they won't show up as of the current version
  * Fixed Adze sometimes making your damage insanely high on the killing blow, thus resulting in stupidly high end-of-run damage numbers
  * Fixed? Exhaust not working for non-host players in multiplayer

* v1.1.1: Visual Enhancement (vials) & Bugfixes
  * Made the icons less crusty, they are now 512x512 instead of 128x128
  * Redid displays for Enhancement Vials, so they're more like Power Elixir
  * Normalizes pickup descriptions
  * Banned Extraterrestrial Exhaust from enemies, as it's busted on a particular enemy
  * Fixed "Bundle of Fireworks" being referred to as just "Fireworks"
  * Prevents Clockwork Mechanism's effect from occuring on stages without normal interactable spawns (ex. Void Fields), but also made it a config because that's a funny feature (but it's off by default)
  * Removed debug messages from Orrery that I guess I didn't notice until now, and cleaned up Exhaust code
  * Removed Luck from tooltip of Executioner's Burden (the effect is still there, it was removed because it makes the item seem like it has two distinct effects while its really just one meaningful one (rewards for killing elites) and it also doesn't stack, so it being in the tooltip is a bit unneeded. It is still in the logbook, and the luck is still editable in the config if you so desire)
  * Redid Thunderstore page. Again. 
  * Removed references to white/green/red tiers on the page because they're void items. They're all purple-pink
  * The NEXT update will rework orrery...probably

* v1.1.0: ""E"" Update
  * Added Enhancement Vials, Extraterrestrial Exhaust, and Executioner's Burden
  * The names all being E wasn't intentional I swear
  * Redid textures on Adze, so it needed a new icon (sorry noop)
  * Redid item displays / pickups for Adze, Clockwork, and Orrery so that the item tier outline shows up properly on them (oops!)
  * Fixes Clockwork Mechanism displaying the base effect twice in its description and not the stacking effect
  * Made the Thunderstore page way nicer because the old one sucked
  * Maybe something else I forgot, this update took way longer than I meant it to
  * Next update will probably rework/buff orrery 

* v1.0.0: Release
  * Hopefully it all works!
</details>